var mongoose = require('../mongoose.js')();

var schema = new mongoose.Schema({
  name: { type: String, require: true },
  spf: { type: Boolean, default: false },
  dkim1: { type: Boolean, default: false },
  dkim2: { type: Boolean, default: false },
  cname: { type: Boolean, default: false },
  spf_data: { type: String, default: '' },
  dkim1_data: { type: String, default: '' },
  dkim2_data: { type: String, default: '' },
  cname_data: { type: String, default: '' },
  spf_host: { type: String, default: '' },
  dkim1_host: { type: String, default: '' },
  dkim2_host: { type: String, default: '' },
  cname_host: { type: String, default: '' },
  spf_type: { type: String, default: 'txt' },
  dkim1_type: { type: String, default: 'cname' },
  dkim2_type: { type: String, default: 'cname' },
  cname_type: { type: String, default: 'cname' },
  created: { type: Date, default: Date.now },
  modified: Date,
  lastTested: String,
  validSigning: { type: Boolean, default: false },
  userId: { type: mongoose.Schema.ObjectId, require: true }
});

schema.index({name: 1, userId: 1}, {unique: true});

schema.pre('save', function (next) {
  this.modified = new Date();
  next();
});

schema.virtual('id').get(function(){
  return this._id.toHexString();
});

schema.set('toJSON', {
  virtuals: true
});

module.exports = mongoose.model('Domain', schema);
